*** /dev/null
--- NetBSD/src/sys/arch/amiga/dev/if_zedreg.h
***************
*** 0 ****
--- 1,43 ----
+ /*	$NetBSD: if_edreg.h,v 1.4 1995/05/08 02:40:54 chopps Exp $	*/
+ 
+ /*
+  * Vendor types
+  */
+ #define	ED_VENDOR_HYDRA		0x03	/* Hydra Systems */
+ 
+ /*
+  * Compile-time config flags
+  */
+ /*
+  * This sets the default for enabling/disablng the tranceiver.
+  */
+ #define ED_FLAGS_DISABLE_TRANCEIVER	0x0001
+ 
+ /*
+  * This forces the board to be used in 8/16-bit mode even if it autoconfigs
+  * differently.
+  */
+ #define ED_FLAGS_FORCE_8BIT_MODE	0x0002
+ #define ED_FLAGS_FORCE_16BIT_MODE	0x0004
+ 
+ /*
+  * This disables the use of double transmit buffers.
+  */
+ #define ED_FLAGS_NO_MULTI_BUFFERING	0x0008
+ 
+ /*
+  * This forces all operations with the NIC memory to use Programmed I/O (i.e.
+  * not via shared memory).
+  */
+ #define ED_FLAGS_FORCE_PIO		0x0010
+ 
+ /*
+  *		Definitions for Hydra Systems boards
+  */
+ #define	HYDRA_ADDRPROM	0xffc0
+ #define	HYDRA_NIC_BASE	0xffe1
+ /*
+  *		Definitions for ASDG LANRover boards
+  */
+ #define ASDG_ADDRPROM	0xff
+ #define ASDG_NIC_BASE	0x1
*** /dev/null
--- NetBSD/src/sys/arch/amiga/dev/if_zle.c
***************
*** 0 ****
--- 1,962 ----
+ /*	$NetBSD: if_le.c,v 1.14 1995/07/02 00:16:06 mycroft Exp $	*/
+ 
+ /*
+  * Copyright (c) 1982, 1990 The Regents of the University of California.
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. All advertising materials mentioning features or use of this software
+  *    must display the following acknowledgement:
+  *	This product includes software developed by the University of
+  *	California, Berkeley and its contributors.
+  * 4. Neither the name of the University nor the names of its contributors
+  *    may be used to endorse or promote products derived from this software
+  *    without specific prior written permission.
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+  * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+  * SUCH DAMAGE.
+  *
+  *	@(#)if_le.c	7.6 (Berkeley) 5/8/91
+  */
+ 
+ #include "le.h"
+ #if NLE > 0
+ 
+ #include "bpfilter.h"
+ 
+ /*
+  * AMD 7990 LANCE
+  *
+  * This driver will generate and accept tailer encapsulated packets even
+  * though it buys us nothing.  The motivation was to avoid incompatibilities
+  * with VAXen, SUNs, and others that handle and benefit from them.
+  * This reasoning is dubious.
+  */
+ #include <sys/param.h>
+ #include <sys/systm.h>
+ #include <sys/mbuf.h>
+ #include <sys/buf.h>
+ #include <sys/protosw.h>
+ #include <sys/socket.h>
+ #include <sys/syslog.h>
+ #include <sys/ioctl.h>
+ #include <sys/errno.h>
+ #include <sys/device.h>
+ 
+ #include <net/if.h>
+ #include <net/netisr.h>
+ #include <net/route.h>
+ 
+ #ifdef INET
+ #include <netinet/in.h>
+ #include <netinet/in_systm.h>
+ #include <netinet/in_var.h>
+ #include <netinet/ip.h>
+ #include <netinet/if_ether.h>
+ #endif
+ 
+ #ifdef NS
+ #include <netns/ns.h>
+ #include <netns/ns_if.h>
+ #endif
+ 
+ #include <machine/cpu.h>
+ #include <machine/mtpr.h>
+ #include <amiga/amiga/device.h>
+ #include <amiga/amiga/isr.h>
+ #include <amiga/dev/zbusvar.h>
+ #include <amiga/dev/if_lereg.h>
+ 
+ /*
+  * Ethernet software status per interface.
+  *
+  * Each interface is referenced by a network interface structure,
+  * le_if, which the routing code uses to locate the interface.
+  * This structure contains the output queue for the interface, its address, ...
+  */
+ struct	le_softc {
+ 	struct	isr sc_isr;
+ 	struct	arpcom sc_ac;	/* common Ethernet structures */
+ #define	sc_if	sc_ac.ac_if	/* network-visible interface */
+ #define	sc_addr	sc_ac.ac_enaddr	/* hardware Ethernet address */
+ 	void	*sc_base;	/* base address of board */
+ 	struct	lereg1 *sc_r1;	/* LANCE registers */
+ 	struct	lereg2 *sc_r2;	/* dual-port RAM */
+ 	int	sc_rmd;		/* predicted next rmd to process */
+ 	int	sc_tmd;		/* next tmd to use */
+ 	int	sc_no_td;	/* number of tmds in use */
+ 	int	sc_runt;
+ 	int	sc_jab;
+ 	int	sc_merr;
+ 	int	sc_babl;
+ 	int	sc_cerr;
+ 	int	sc_miss;
+ 	int	sc_xint;
+ 	int	sc_xown;
+ 	int	sc_uflo;
+ 	int	sc_rxlen;
+ 	int	sc_rxoff;
+ 	int	sc_txoff;
+ 	int	sc_busy;
+ 	short	sc_iflags;
+ #if NBPFILTER > 0
+ 	caddr_t sc_bpf;
+ #endif
+ } le_softc[NLE];
+ 
+ #if NBPFILTER > 0
+ #include <net/bpf.h>
+ #include <net/bpfdesc.h>
+ #endif
+ 
+ /* offsets for:	   ID,   REGS,    MEM */
+ int	lestd[] = { 0, 0x4000, 0x8000 };
+ 
+ /* console error messages */
+ int	ledebug = 0;
+ 
+ int leioctl __P((struct ifnet *, u_long, caddr_t));
+ int leintr __P((struct le_softc *));
+ void lestart __P((struct ifnet *));
+ void leinit __P((int));
+ 
+ struct	mbuf *leget();
+ extern	struct ifnet loif;
+ 
+ void leattach __P((struct device *, struct device *, void *));
+ int lematch __P((struct device *, struct cfdata *, void *args));
+ 
+ struct cfdriver lecd = {
+ 	NULL, "le", (cfmatch_t)lematch, leattach, DV_IFNET,
+ 	sizeof(struct le_softc), NULL, 0};
+ 
+ int
+ lematch(pdp, cfp, auxp)
+ 	struct device *pdp;
+ 	struct cfdata *cfp;
+ 	void *auxp;
+ {
+ 
+ 	struct zbus_args *zap;
+ 
+ 	zap = (struct zbus_args *)auxp;
+ 
+ 	/* Commodore ethernet card */
+ 	if ( zap->manid == 514 && zap->prodid == 112)
+ 		return(1);
+ 
+ 	/* Ameristar ethernet card */
+ 	if ( zap->manid == 1053 && zap->prodid == 1)
+ 		return(1);
+ 
+ 	return (0);
+ }
+ 
+ /*
+  * Interface exists: make available by filling in network interface
+  * record.  System will initialize the interface when it is ready
+  * to accept packets.
+  */
+ void
+ leattach(pdp, dp, auxp)
+ 	struct device *pdp, *dp;
+ 	void *auxp;
+ {
+ 	register struct lereg0 *ler0;
+ 	register struct lereg2 *ler2;
+ 	struct zbus_args *zap;
+ 	struct lereg2 *lemem = (struct lereg2 *) 0x8000;
+ 	struct le_softc *le = &le_softc[dp->dv_unit];
+ 	struct ifnet *ifp = &le->sc_if;
+ 	char *cp;
+ 	int i;
+ 	unsigned long ser;
+ 	int s = splhigh ();
+ 
+ 	zap =(struct zbus_args *)auxp;
+ 
+ 	/*
+ 	 * Make config msgs look nicer.
+ 	 */
+ 	printf("\n");
+ 
+ 	ler0 = le->sc_base = zap->va;
+ 	le->sc_r1 = (struct lereg1 *)(lestd[1] + (int)zap->va);
+ 	ler2 = le->sc_r2 = (struct lereg2 *)(lestd[2] + (int)zap->va);
+ 
+ 	/*
+ 	 * Manufacturer decides the 3 first bytes, i.e. ethernet vendor ID.
+ 	 */
+ 	if ( zap->manid == 514 && zap->prodid == 112) {
+ 	    /* Commodore 2065 */
+ 	    le->sc_addr[0] = 0x00;
+ 	    le->sc_addr[1] = 0x80;
+ 	    le->sc_addr[2] = 0x10;
+ 	}
+ 	if ( zap->manid == 1053 && zap->prodid == 1) {
+ 	    le->sc_addr[0] = 0x00;
+ 	    le->sc_addr[1] = 0x00;
+ 	    le->sc_addr[2] = 0x9f;
+ 	}
+ 
+ 	/*
+ 	 * Serial number for board is used as host ID.
+ 	 */
+ 	ser = (unsigned long) zap->serno;
+ 
+ 	le->sc_addr[3] = (ser >> 16) & 0xff;
+ 	le->sc_addr[4] = (ser >>  8) & 0xff;
+ 	le->sc_addr[5] = (ser      ) & 0xff;
+ 
+ #ifdef LE_USE_16K
+ 	printf("le%d: hardware address %s 16K\n",
+ #else
+ 	printf("le%d: hardware address %s 32K\n",
+ #endif
+ 	dp->dv_unit, ether_sprintf(le->sc_addr));
+ 
+ 	/*
+ 	 * Setup for transmit/receive
+ 	 */
+ 	ler2->ler2_mode = LE_MODE;
+ 	ler2->ler2_padr[0] = le->sc_addr[1];
+ 	ler2->ler2_padr[1] = le->sc_addr[0];
+ 	ler2->ler2_padr[2] = le->sc_addr[3];
+ 	ler2->ler2_padr[3] = le->sc_addr[2];
+ 	ler2->ler2_padr[4] = le->sc_addr[5];
+ 	ler2->ler2_padr[5] = le->sc_addr[4];
+ 	ler2->ler2_ladrf0 = 0;
+ 	ler2->ler2_ladrf1 = 0;
+ 	ler2->ler2_rlen = LE_RLEN;
+ 	ler2->ler2_rdra = (int)lemem->ler2_rmd;
+ 	ler2->ler2_tlen = LE_TLEN;
+ 	ler2->ler2_tdra = (int)lemem->ler2_tmd;
+ 
+ 	splx (s);
+ 
+ 	ifp->if_unit = dp->dv_unit;
+ 	ifp->if_name = "le";
+ 	ifp->if_mtu = ETHERMTU;
+ 	ifp->if_ioctl = leioctl;
+ 	ifp->if_output = ether_output;
+ 	ifp->if_start = lestart;
+ 	ifp->if_flags = IFF_BROADCAST | IFF_SIMPLEX;
+ 
+ #if NBPFILTER > 0
+ 	bpfattach(&le->sc_bpf, ifp, DLT_EN10MB, sizeof(struct ether_header));
+ #endif
+ 	if_attach(ifp);
+ 	ether_ifattach(ifp);
+ 
+ 	le->sc_isr.isr_intr = leintr;
+ 	le->sc_isr.isr_arg = le;
+ 	le->sc_isr.isr_ipl = 2;
+ 	add_isr (&le->sc_isr);
+ 
+ 	le->sc_isr.isr_intr = leintr;
+ 	le->sc_isr.isr_arg = le;
+ 	le->sc_isr.isr_ipl = 2;
+ 	add_isr (&le->sc_isr);
+ 
+ 	return;
+ }
+ 
+ ledrinit(ler2)
+ 	register struct lereg2 *ler2;
+ {
+ 	register struct lereg2 *lemem = (struct lereg2 *) 0x8000;
+ 	register int i;
+ 
+ 	for (i = 0; i < LERBUF; i++) {
+ 		ler2->ler2_rmd[i].rmd0 = (int)lemem->ler2_rbuf[i];
+ 		ler2->ler2_rmd[i].rmd1 = LE_OWN;
+ 		ler2->ler2_rmd[i].rmd2 = -LEMTU;
+ 		ler2->ler2_rmd[i].rmd3 = 0;
+ 	}
+ 
+ 	for (i = 0; i < LETBUF; i++) {
+ 		ler2->ler2_tmd[i].tmd0 = (int)lemem->ler2_tbuf[i];
+ 		ler2->ler2_tmd[i].tmd1 = 0;
+ 		ler2->ler2_tmd[i].tmd2 = 0;
+ 		ler2->ler2_tmd[i].tmd3 = 0;
+ 	}
+ }
+ 
+ void
+ lereset(unit)
+ 	register int unit;
+ {
+ 	register struct le_softc *le = &le_softc[unit];
+ 	register struct lereg1 *ler1 = le->sc_r1;
+ 	/*
+ 	 * This structure is referenced from the CARDS/LANCE point of
+ 	 * view, thus the 0x8000 address which is the buffer RAM area of
+ 	 * the Commodore and Ameristar cards. This pointer is manipulated
+ 	 * with the LANCE's view of memory and NOT the Amiga's. FYI.
+ 	 */
+ 	register struct lereg2 *lemem = (struct lereg2 *) 0x8000;
+ 
+ 	register int timo = 100000;
+ 	register int stat;
+ 
+ #ifdef lint
+ 	stat = unit;
+ #endif
+ #if NBPFILTER > 0
+ 	if (le->sc_if.if_flags & IFF_PROMISC)
+ 		/* set the promiscuous bit */
+ 		le->sc_r2->ler2_mode = LE_MODE|0x8000;
+ 	else
+ 		le->sc_r2->ler2_mode = LE_MODE;
+ #endif
+ 	 ler1->ler1_rap =  LE_CSR0;
+ 	 ler1->ler1_rdp =  LE_STOP;
+ 
+ 	 ledrinit(le->sc_r2);
+ 
+ 	 le->sc_rmd = le->sc_tmd = le->sc_no_td = 0;
+ 	 ler1->ler1_rap =  LE_CSR1;
+ 	 ler1->ler1_rdp =  (int)&lemem->ler2_mode;
+ 	 ler1->ler1_rap =  LE_CSR2;
+ 	 ler1->ler1_rdp =  0;
+ 	 ler1->ler1_rap =  LE_CSR0;
+ 	 ler1->ler1_rdp =  LE_INIT;
+ 
+ 	do {
+ 		if (--timo == 0) {
+ 			printf("le%d: init timeout, stat = 0x%x\n",
+ 			       unit, stat);
+ 			break;
+ 		}
+ 		 stat =  ler1->ler1_rdp;
+ 	} while ((stat & LE_IDON) == 0);
+ 
+ 	 ler1->ler1_rdp =  LE_STOP;
+ 	 ler1->ler1_rap =  LE_CSR3;
+ 	 ler1->ler1_rdp =  LE_BSWP;
+ 	 ler1->ler1_rap =  LE_CSR0;
+ 	 ler1->ler1_rdp =  LE_STRT | LE_INEA;
+ 	 le->sc_if.if_flags &= ~IFF_OACTIVE;
+ 
+ 	return;
+ }
+ 
+ /*
+  * Initialization of interface
+  */
+ void
+ leinit(unit)
+ 	int unit;
+ {
+ 	struct le_softc *le = &le_softc[unit];
+ 	register struct ifnet *ifp = &le->sc_if;
+ 	int s;
+ 
+ 	if ((ifp->if_flags & IFF_RUNNING) == 0) {
+ 		s = splimp();
+ 		ifp->if_flags |= IFF_RUNNING;
+ 		lereset(unit);
+ 	        (void) lestart(ifp);
+ 		splx(s);
+ 	}
+ 
+ 	return;
+ }
+ 
+ #define LENEXTTMP \
+ 	if (++bix == LETBUF) bix = 0, tmd = le->sc_r2->ler2_tmd; else ++tmd
+ 
+ /*
+  * Start output on interface.  Get another datagram to send
+  * off of the interface queue, and copy it to the interface
+  * before starting the output.
+  */
+ void
+ lestart(ifp)
+ 	struct ifnet *ifp;
+ {
+ 	register struct le_softc *le = &le_softc[ifp->if_unit];
+ 	register int bix;
+ 	register struct letmd *tmd;
+ 	register struct mbuf *m;
+ 	int len;
+ 
+ 	if ((le->sc_if.if_flags & IFF_RUNNING) == 0)
+ 		return;
+ 
+ 	bix = le->sc_tmd;
+ 	tmd = &le->sc_r2->ler2_tmd[bix];
+ 
+ 	for (;;) {
+ 		if (le->sc_no_td >= LETBUF) {
+ 			le->sc_if.if_flags |= IFF_OACTIVE;
+ 			break;
+ 		}
+ 
+ 		IF_DEQUEUE(&le->sc_if.if_snd, m);
+ 		if (m == 0)
+ 			break;
+ 
+ 		++le->sc_no_td;
+ 
+ 		len = leput(le->sc_r2->ler2_tbuf[bix], m);
+ 
+ #if NBPFILTER > 0
+ 		/*
+ 		 * If bpf is listening on this interface, let it
+ 		 * see the packet before we commit it to the wire.
+ 		 */
+ 		if (le->sc_bpf)
+         	        bpf_tap(le->sc_bpf, le->sc_r2->ler2_tbuf[bix], len);
+ #endif
+ 
+ 		tmd->tmd3 = 0;
+ 		tmd->tmd2 = -len;
+ 		tmd->tmd1 = LE_OWN | LE_STP | LE_ENP;
+ 
+ 		LENEXTTMP;
+ 	}
+ 
+ 	le->sc_tmd = bix;
+ }
+ 
+ int
+ leintr(le)
+ 	struct le_softc *le;
+ {
+ #if 0
+ 	register struct le_softc *le = &le_softc[unit];
+ #else
+ 	int unit = le->sc_if.if_unit;
+ #endif
+ 	register struct lereg1 *ler1;
+ 	register int stat;
+ 
+ 	/* if not even initialized, don't do anything further.. */
+ 	if (! le->sc_base)
+ 	  return 0;
+ 
+ 	ler1 = le->sc_r1;
+ 	stat =  ler1->ler1_rdp;
+ 
+ 	if (! (stat & LE_INTR))
+ 	  return 0;
+ 
+ 	if (stat & LE_SERR) {
+ 		leerror(unit, stat);
+ 		if (stat & LE_MERR) {
+ 			le->sc_merr++;
+ 			lereset(unit);
+ 			return(1);
+ 		}
+ 		if (stat & LE_BABL)
+ 			le->sc_babl++;
+ 		if (stat & LE_CERR)
+ 			le->sc_cerr++;
+ 		if (stat & LE_MISS)
+ 			le->sc_miss++;
+ 		 ler1->ler1_rdp =  LE_BABL|LE_CERR|LE_MISS|LE_INEA;
+ 	}
+ 	if ((stat & LE_RXON) == 0) {
+ 		le->sc_rxoff++;
+ 		lereset(unit);
+ 		return(1);
+ 	}
+ 	if ((stat & LE_TXON) == 0) {
+ 		le->sc_txoff++;
+ 		lereset(unit);
+ 		return(1);
+ 	}
+ 	if (stat & LE_RINT) {
+ 		/* interrupt is cleared in lerint */
+ 		lerint(unit);
+ 	}
+ 	if (stat & LE_TINT) {
+ 		 ler1->ler1_rdp =  LE_TINT|LE_INEA;
+ 		lexint(unit);
+ 	}
+ 	return(1);
+ }
+ 
+ /*
+  * Ethernet interface transmitter interrupt.
+  * Start another output if more data to send.
+  */
+ lexint(unit)
+ 	register int unit;
+ {
+ 	register struct le_softc *le = &le_softc[unit];
+ 	register int bix = (le->sc_tmd - le->sc_no_td + LETBUF) % LETBUF;
+ 	register struct letmd *tmd = &le->sc_r2->ler2_tmd[bix];
+ 
+ 	if ((le->sc_if.if_flags & IFF_OACTIVE) == 0) {
+ 		le->sc_xint++;
+ 		return;
+ 	}
+ 	if (tmd->tmd1 & LE_OWN) {
+ printf("le%d: extra xint\n", unit);
+ 		le->sc_xown++;
+ 		return;
+ 	}
+ 	le->sc_if.if_flags &= ~IFF_OACTIVE;
+ 
+ 	do {
+ 		if (le->sc_no_td <= 0)
+ 			break;
+ 		--le->sc_no_td;
+ 
+ 		if (tmd->tmd1 & LE_ERR) {
+ err:
+ printf("le%d: xint error\n", unit);
+ 			lexerror(unit);
+ 			le->sc_if.if_oerrors++;
+ 			if (tmd->tmd3 & (LE_TBUFF|LE_UFLO)) {
+ 				le->sc_uflo++;
+ 				lereset(unit);
+ 				return;
+ 			}
+ 			else if (tmd->tmd3 & LE_LCOL)
+ 				le->sc_if.if_collisions++;
+ 			else if (tmd->tmd3 & LE_RTRY)
+ 				le->sc_if.if_collisions += 16;
+ 		}
+ 		else if (tmd->tmd3 & LE_TBUFF)
+ 			/* XXX documentation says BUFF not included in ERR */
+ 			goto err;
+ 		else if (tmd->tmd1 & LE_ONE)
+ 			le->sc_if.if_collisions++;
+ 		else if (tmd->tmd1 & LE_MORE)
+ 			/* what is the real number? */
+ 			le->sc_if.if_collisions += 2;
+ 		else
+ 			le->sc_if.if_opackets++;
+ 		LENEXTTMP;
+ 	} while ((tmd->tmd1 & LE_OWN) == 0);
+ 
+ 	(void) lestart(&le->sc_if);
+ }
+ 
+ #define	LENEXTRMP \
+ 	if (++bix == LERBUF) bix = 0, rmd = le->sc_r2->ler2_rmd; else ++rmd
+ 
+ /*
+  * Ethernet interface receiver interrupt.
+  * If input error just drop packet.
+  * Decapsulate packet based on type and pass to type specific
+  * higher-level input routine.
+  */
+ lerint(unit)
+ 	int unit;
+ {
+ 	register struct le_softc *le = &le_softc[unit];
+ 	register int bix = le->sc_rmd;
+ 	register struct lermd *rmd = &le->sc_r2->ler2_rmd[bix];
+ 
+ 	/*
+ 	 * Out of sync with hardware, should never happen?
+ 	 */
+ 	if (rmd->rmd1 & LE_OWN) {
+ 		 le->sc_r1->ler1_rdp =  LE_RINT|LE_INEA;
+ 		return;
+ 	}
+ 
+ 	/*
+ 	 * Process all buffers with valid data
+ 	 */
+ 	while ((rmd->rmd1 & LE_OWN) == 0) {
+ 		int len = rmd->rmd3;
+ 
+ 		/* Clear interrupt to avoid race condition */
+ 		 le->sc_r1->ler1_rdp =  LE_RINT|LE_INEA;
+ 
+ 		if (rmd->rmd1 & LE_ERR) {
+ 			le->sc_rmd = bix;
+ 			lererror(unit, "bad packet");
+ 			le->sc_if.if_ierrors++;
+ 		} else if ((rmd->rmd1 & (LE_STP|LE_ENP)) != (LE_STP|LE_ENP)) {
+ 			/*
+ 			 * Find the end of the packet so we can see how long
+ 			 * it was.  We still throw it away.
+ 			 */
+ 			do {
+ 			        le->sc_r1->ler1_rdp = LE_RINT|LE_INEA;
+ 				rmd->rmd3 = 0;
+ 				rmd->rmd1 = LE_OWN;
+ 				LENEXTRMP;
+ 			} while (!(rmd->rmd1 & (LE_OWN|LE_ERR|LE_STP|LE_ENP)));
+ 
+ 			le->sc_rmd = bix;
+ 			lererror(unit, "chained buffer");
+ 			le->sc_rxlen++;
+ 
+ 			/*
+ 			 * If search terminated without successful completion
+ 			 * we reset the hardware (conservative).
+ 			 */
+ 			if ((rmd->rmd1 & (LE_OWN|LE_ERR|LE_STP|LE_ENP)) != LE_ENP) {
+ 				lereset(unit);
+ 				return;
+ 			}
+ 		} else
+ 			leread(unit, le->sc_r2->ler2_rbuf[bix], len);
+ 
+ 		rmd->rmd3 = 0;
+ 		rmd->rmd1 = LE_OWN;
+ 		LENEXTRMP;
+ 
+ 	}
+ 
+ 	le->sc_rmd = bix;
+ }
+ 
+ leread(unit, buf, len)
+ 	int unit;
+ 	char *buf;
+ 	int len;
+ {
+ 	register struct le_softc *le = &le_softc[unit];
+ 	register struct ether_header *et;
+     	struct mbuf *m;
+ 	int off, resid;
+ 
+ 	le->sc_if.if_ipackets++;
+ 
+ 	et = (struct ether_header *)buf;
+ 	et->ether_type = ntohs((u_short)et->ether_type);
+ 
+ 	/* adjust input length to account for header and CRC */
+ 	len = len - sizeof(struct ether_header) - 4;
+ 
+ #define	ledataaddr(et, off, type)	((type)(((caddr_t)((et)+1)+(off))))
+ 	if (et->ether_type >= ETHERTYPE_TRAIL &&
+ 	    et->ether_type < ETHERTYPE_TRAIL+ETHERTYPE_NTRAILER) {
+ 		off = (et->ether_type - ETHERTYPE_TRAIL) * 512;
+ 		if (off >= ETHERMTU)
+ 			return;		/* sanity */
+ 		et->ether_type = ntohs(*ledataaddr(et, off, u_short *));
+ 		resid = ntohs(*(ledataaddr(et, off+2, u_short *)));
+ 		if (off + resid > len)
+ 			return;		/* sanity */
+ 		len = off + resid;
+ 	} else
+ 		off = 0;
+ 
+ 	if (len <= 0) {
+ 		if (ledebug)
+ 			log(LOG_WARNING,
+ 			    "le%d: ierror(runt packet): from %s: len=%d\n",
+ 			    unit, ether_sprintf(et->ether_shost), len);
+ 		le->sc_runt++;
+ 		le->sc_if.if_ierrors++;
+ 		return;
+ 	}
+ #if NBPFILTER > 0
+ 	/*
+ 	 * Check if there's a bpf filter listening on this interface.
+ 	 * If so, hand off the raw packet to bpf, which must deal with
+ 	 * trailers in its own way.
+ 	 */
+ 	if (le->sc_bpf) {
+ 		bpf_tap(le->sc_bpf, buf, len + sizeof(struct ether_header));
+ 
+ 		/*
+ 		 * Note that the interface cannot be in promiscuous mode if
+ 		 * there are no bpf listeners.  And if we are in promiscuous
+ 		 * mode, we have to check if this packet is really ours.
+ 		 *
+ 		 * XXX This test does not support multicasts.
+ 		 */
+ 		if ((le->sc_if.if_flags & IFF_PROMISC)
+ 		    && bcmp(et->ether_dhost, le->sc_addr, 
+ 			    sizeof(et->ether_dhost)) != 0
+ 		    && bcmp(et->ether_dhost, etherbroadcastaddr, 
+ 			    sizeof(et->ether_dhost)) != 0)
+ 			return;
+ 	}
+ #endif
+ 	/*
+ 	 * Pull packet off interface.  Off is nonzero if packet
+ 	 * has trailing header; leget will then force this header
+ 	 * information to be at the front, but we still have to drop
+ 	 * the type and length which are at the front of any trailer data.
+ 	 */
+ 	m = leget(buf, len, off, &le->sc_if);
+ 	if (m == 0)
+ 		return;
+ 
+ 	ether_input(&le->sc_if, et, m);
+ }
+ 
+ /*
+  * Routine to copy from mbuf chain to transmit
+  * buffer in board local memory.
+  */
+ leput(lebuf, m)
+ 	register char *lebuf;
+ 	register struct mbuf *m;
+ {
+ 	register struct mbuf *mp;
+ 	register int len, tlen = 0;
+ 
+ 	for (mp = m; mp; mp = mp->m_next) {
+ 		len = mp->m_len;
+ 		if (len == 0)
+ 			continue;
+ 		tlen += len;
+ 		bcopy(mtod(mp, char *), lebuf, len);
+ 		lebuf += len;
+ 	}
+ 
+ 	m_freem(m);
+ 
+ 	if (tlen < LEMINSIZE) {
+ 		bzero(lebuf, LEMINSIZE - tlen);
+ 		tlen = LEMINSIZE;
+ 	}
+ 
+ 	return(tlen);
+ }
+ 
+ /*
+  * Routine to copy from board local memory into mbufs.
+  */
+ struct mbuf *
+ leget(lebuf, totlen, off0, ifp)
+ 	char *lebuf;
+ 	int totlen, off0;
+ 	struct ifnet *ifp;
+ {
+ 	register struct mbuf *m;
+ 	struct mbuf *top = 0, **mp = &top;
+ 	register int off = off0, len;
+ 	register char *cp;
+ 	char *epkt;
+ 
+ 	lebuf += sizeof (struct ether_header);
+ 	cp = lebuf;
+ 	epkt = cp + totlen;
+ 	if (off) {
+ 		cp += off + 2 * sizeof(u_short);
+ 		totlen -= 2 * sizeof(u_short);
+ 	}
+ 
+ 	MGETHDR(m, M_DONTWAIT, MT_DATA);
+ 
+ 	if (m == 0)
+ 		return (0);
+ 
+ 	m->m_pkthdr.rcvif = ifp;
+ 	m->m_pkthdr.len = totlen;
+ 	m->m_len = MHLEN;
+ 
+ 	while (totlen > 0) {
+ 
+ 		if (top) {
+ 			MGET(m, M_DONTWAIT, MT_DATA);
+ 			if (m == 0) {
+ 				m_freem(top);
+ 				return (0);
+ 			}
+ 			m->m_len = MLEN;
+ 		}
+ 
+ 		len = min(totlen, epkt - cp);
+ 		if (len >= MINCLSIZE) {
+ 			MCLGET(m, M_DONTWAIT);
+ 			if (m->m_flags & M_EXT)
+ 				m->m_len = len = min(len, MCLBYTES);
+ 			else
+ 				len = m->m_len;
+ 		} else {
+ 			/*
+ 			 * Place initial small packet/header at end of mbuf.
+ 			 */
+ 			if (len < m->m_len) {
+ 				if (top == 0 && len + max_linkhdr <= m->m_len)
+ 					m->m_data += max_linkhdr;
+ 				m->m_len = len;
+ 			} else
+ 				len = m->m_len;
+ 		}
+ 
+ 		bcopy(cp, mtod(m, caddr_t), (unsigned)len);
+ 		cp += len;
+ 		*mp = m;
+ 		mp = &m->m_next;
+ 		totlen -= len;
+ 
+ 		if (cp == epkt)
+ 			cp = lebuf;
+ 
+ 	}
+ 
+ 	return (top);
+ }
+ 
+ /*
+  * Process an ioctl request.
+  */
+ int
+ leioctl(ifp, cmd, data)
+ 	register struct ifnet *ifp;
+ 	u_long cmd;
+ 	caddr_t data;
+ {
+ 	register struct ifaddr *ifa = (struct ifaddr *)data;
+ 	struct le_softc *le = &le_softc[ifp->if_unit];
+ 	struct lereg1 *ler1 = le->sc_r1;
+ 	int s = splimp(), error = 0;
+ 
+ 	switch (cmd) {
+ 
+ 	case SIOCSIFADDR:
+ 		ifp->if_flags |= IFF_UP;
+ 		switch (ifa->ifa_addr->sa_family) {
+ #ifdef INET
+ 		case AF_INET:
+ 			leinit(ifp->if_unit);
+ 			arp_ifinit(&le->sc_ac, ifa);
+ 			break;
+ #endif
+ #ifdef NS
+ 		case AF_NS:
+ 		    {
+ 			register struct ns_addr *ina = &(IA_SNS(ifa)->sns_addr);
+ 
+ 			if (ns_nullhost(*ina))
+ 				ina->x_host = *(union ns_host *)(le->sc_addr);
+ 			else {
+ 				/* 
+ 				 * The manual says we can't change the address 
+ 				 * while the receiver is armed,
+ 				 * so reset everything
+ 				 */
+ 				ifp->if_flags &= ~IFF_RUNNING; 
+ 				bcopy((caddr_t)ina->x_host.c_host,
+ 				    (caddr_t)le->sc_addr, sizeof(le->sc_addr));
+ 			}
+ 			leinit(ifp->if_unit); /* does le_setaddr() */
+ 			break;
+ 		    }
+ #endif
+ 		default:
+ 			leinit(ifp->if_unit);
+ 			break;
+ 		}
+ 		break;
+ 
+ 	case SIOCSIFFLAGS:
+ 		if ((ifp->if_flags & IFF_UP) == 0 &&
+ 		    ifp->if_flags & IFF_RUNNING) {
+ 			 ler1->ler1_rdp =  LE_STOP;
+ 			ifp->if_flags &= ~IFF_RUNNING;
+ 		} else if (ifp->if_flags & IFF_UP && (ifp->if_flags & IFF_RUNNING) == 0)
+ 			leinit(ifp->if_unit);
+ 
+ 		/*
+ 		 * If the state of the promiscuous bit changes, the interface
+ 		 * must be reset to effect the change.
+ 		 */
+ 		if (((ifp->if_flags ^ le->sc_iflags) & IFF_PROMISC) && (ifp->if_flags & IFF_RUNNING)) {
+ 			le->sc_iflags = ifp->if_flags;
+ 			lereset(ifp->if_unit);
+ 			lestart(ifp);
+ 		}
+ 		break;
+ 
+ 	default:
+ 		error = EINVAL;
+ 	}
+ 
+ 	splx(s);
+ 	return (error);
+ }
+ 
+ leerror(unit, stat)
+ 	int unit;
+ 	int stat;
+ {
+ 	if (!ledebug)
+ 		return;
+ 
+ 	/*
+ 	 * Not all transceivers implement heartbeat
+ 	 * so we only log CERR once.
+ 	 */
+ 	if ((stat & LE_CERR) && le_softc[unit].sc_cerr)
+ 		return;
+ 
+ 	log(LOG_WARNING,
+ 	    "le%d: error: stat=%b\n", unit,
+ 	    stat,
+ 	    "\20\20ERR\17BABL\16CERR\15MISS\14MERR\13RINT\12TINT\11IDON\10INTR\07INEA\06RXON\05TXON\04TDMD\03STOP\02STRT\01INIT");
+ }
+ 
+ lererror(unit, msg)
+ 	int unit;
+ 	char *msg;
+ {
+ 	register struct le_softc *le = &le_softc[unit];
+ 	register struct lermd *rmd;
+ 	int len;
+ 
+ 	if (!ledebug)
+ 		return;
+ 
+ 	rmd = &le->sc_r2->ler2_rmd[le->sc_rmd];
+ 	len = rmd->rmd3;
+ 
+ 	log(LOG_WARNING,
+ 	    "le%d: ierror(%s): from %s: buf=%d, len=%d, rmd1=%b\n",
+ 	    unit, msg,
+ 	    len > 11 ? ether_sprintf(&le->sc_r2->ler2_rbuf[le->sc_rmd][6]) : "unknown",
+ 	    le->sc_rmd, len,
+ 	    rmd->rmd1,
+ 	    "\20\20OWN\17ERR\16FRAM\15OFLO\14CRC\13RBUF\12STP\11ENP");
+ }
+ 
+ lexerror(unit)
+ 	int unit;
+ {
+ 	register struct le_softc *le = &le_softc[unit];
+ 	int bix;
+ 	register struct letmd *tmd;
+ 	int len;
+ 
+ 	if (!ledebug)
+ 		return;
+ 
+ 	bix = (le->sc_tmd - le->sc_no_td + LETBUF) % LETBUF;
+ 	tmd = &le->sc_r2->ler2_tmd[bix];
+ 	len = -tmd->tmd2;
+ 
+ 	log(LOG_WARNING,
+ 	    "le%d: oerror: to %s: buf=%d, len=%d, tmd1=%b, tmd3=%b\n",
+ 	    unit,
+ 	    len > 5 ? ether_sprintf(&le->sc_r2->ler2_tbuf[0][0]) : "unknown",
+ 	    0, len,
+ 	    tmd->tmd1,
+ 	    "\20\20OWN\17ERR\16RES\15MORE\14ONE\13DEF\12STP\11ENP",
+ 	    tmd->tmd3,
+ 	    "\20\20BUFF\17UFLO\16RES\15LCOL\14LCAR\13RTRY");
+ }
+ 
+ #endif
+ 
+ 
*** /dev/null
--- NetBSD/src/sys/arch/amiga/dev/if_zlereg.h
***************
*** 0 ****
--- 1,175 ----
+ /*	$NetBSD: if_lereg.h,v 1.5 1994/12/28 09:25:30 chopps Exp $	*/
+ 
+ /*
+  * Copyright (c) 1982, 1990 The Regents of the University of California.
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. All advertising materials mentioning features or use of this software
+  *    must display the following acknowledgement:
+  *	This product includes software developed by the University of
+  *	California, Berkeley and its contributors.
+  * 4. Neither the name of the University nor the names of its contributors
+  *    may be used to endorse or promote products derived from this software
+  *    without specific prior written permission.
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+  * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+  * SUCH DAMAGE.
+  *
+  *	@(#)if_lereg.h	7.1 (Berkeley) 5/8/90
+  */
+ 
+ #define	LEID		21
+ 
+ #define	LEMTU		1518
+ #define	LEMINSIZE	60	/* should be 64 if mode DTCR is set */
+ 
+ /* HP seems to have 16K RAM on board, A2065/Ameristar come with 32K.
+    First try to get a working driver with the HP values, and later 
+    try and see whether 32K works too. */
+ #define LE_USE_32K
+ 
+ #ifdef LE_USE_16K
+ #define	LERBUF		8
+ #define	LERBUFLOG2	3
+ #define	LETBUF		4
+ #define	LETBUFLOG2	2
+ #else /* 32K */
+ #define LERBUF		16
+ #define LERBUFLOG2	4
+ #define LETBUF		4
+ #define LETBUFLOG2	2
+ #endif
+ 
+ #define	LE_RLEN		(LERBUFLOG2 << 13)
+ #define	LE_TLEN		(LETBUFLOG2 << 13)
+ 
+ #define vu_char		volatile u_char
+ 
+ /*
+  * LANCE registers.
+  */
+ #if 0
+ /* doesn't exist on amiga, there's autoconfig registers in this area  */
+ struct lereg0 {
+ 	u_char	ler0_pad0;
+ 	vu_char	ler0_id;	/* ID */
+ 	u_char	ler0_pad1;
+ 	vu_char	ler0_status;	/* interrupt enable/status */
+ };
+ #endif
+ 
+ struct lereg1 {
+ 	u_short	ler1_rdp;	/* data port */
+ 	u_short	ler1_rap;	/* register select port */
+ };
+ 
+ /*
+  * Overlayed on 16K dual-port RAM.
+  * Current size is 13,758 bytes with 8 x 1518 receive buffers and
+  * 1 x 1518 transmit buffer.
+  */
+ struct lereg2 {
+ 	/* init block */
+ 	u_short	ler2_mode;		/* +0x0000 */
+ 	u_char	ler2_padr[6];		/* +0x0002 */
+ 	u_long	ler2_ladrf0;		/* +0x0008 */
+ 	u_long	ler2_ladrf1;		/* +0x000C */
+ 	u_short	ler2_rdra;		/* +0x0010 */
+ 	u_short	ler2_rlen;		/* +0x0012 */
+ 	u_short	ler2_tdra;		/* +0x0014 */
+ 	u_short	ler2_tlen;		/* +0x0016 */
+ 	/* receive message descriptors */
+ 	struct	lermd {			/* +0x0018 */
+ 		u_short	rmd0;
+ 		u_short	rmd1;
+ 		short	rmd2;
+ 		u_short	rmd3;
+ 	} ler2_rmd[LERBUF];
+ 	/* transmit message descriptors */
+ 	struct	letmd {			/* +0x0058 */
+ 		u_short	tmd0;
+ 		u_short	tmd1;
+ 		short	tmd2;
+ 		u_short	tmd3;
+ 	} ler2_tmd[LETBUF];
+ 	char	ler2_rbuf[LERBUF][LEMTU]; /* +0x0060 */
+ 	char	ler2_tbuf[LETBUF][LEMTU]; /* +0x2FD0 */
+ };
+ 
+ #if 0
+ /*
+  * Control and status bits -- lereg0
+  */
+ #define	LE_IE		0x80		/* interrupt enable */
+ #define	LE_IR		0x40		/* interrupt requested */
+ #define	LE_LOCK		0x08		/* lock status register */
+ #define	LE_ACK		0x04		/* ack of lock */
+ #define	LE_JAB		0x02		/* loss of tx clock (???) */
+ #define LE_IPL(x)	((((x) >> 4) & 0x3) + 3)
+ #endif
+ 
+ /*
+  * Control and status bits -- lereg1
+  */
+ #define	LE_CSR0		0
+ #define	LE_CSR1		1
+ #define	LE_CSR2		2
+ #define	LE_CSR3		3
+ 
+ #define	LE_SERR		0x8000
+ #define	LE_BABL		0x4000
+ #define	LE_CERR		0x2000
+ #define	LE_MISS		0x1000
+ #define	LE_MERR		0x0800
+ #define	LE_RINT		0x0400
+ #define	LE_TINT		0x0200
+ #define	LE_IDON		0x0100
+ #define	LE_INTR		0x0080
+ #define	LE_INEA		0x0040
+ #define	LE_RXON		0x0020
+ #define	LE_TXON		0x0010
+ #define	LE_TDMD		0x0008
+ #define	LE_STOP		0x0004
+ #define	LE_STRT		0x0002
+ #define	LE_INIT		0x0001
+ 
+ #define	LE_BSWP		0x4
+ #define	LE_MODE		0x0
+ 
+ /*
+  * Control and status bits -- lereg2
+  */
+ #define	LE_OWN		0x8000
+ #define	LE_ERR		0x4000
+ #define	LE_STP		0x0200
+ #define	LE_ENP		0x0100
+ 
+ #define	LE_FRAM		0x2000
+ #define	LE_OFLO		0x1000
+ #define	LE_CRC		0x0800
+ #define	LE_RBUFF	0x0400
+ #define	LE_MORE		0x1000
+ #define	LE_ONE		0x0800
+ #define	LE_DEF		0x0400
+ #define	LE_TBUFF	0x8000
+ #define	LE_UFLO		0x4000
+ #define	LE_LCOL		0x1000
+ #define	LE_LCAR		0x0800
+ #define	LE_RTRY		0x0400
*** old-NetBSD/src/sys/arch/amiga/dev/ite.c
--- NetBSD/src/sys/arch/amiga/dev/ite.c
***************
*** 295,306 ****
  }
  
  /*
!  * ite_cnfinish() is called in ite_init() when the device is
   * being probed in the normal fasion, thus we can finish setting
   * up this ite now that the system is more functional.
   */
  void
! ite_cnfinish(ip)
  	struct ite_softc *ip;
  {
  	static int done;
--- 295,306 ----
  }
  
  /*
!  * itecnfinish() is called in iteinit() when the device is
   * being probed in the normal fasion, thus we can finish setting
   * up this ite now that the system is more functional.
   */
  void
! itecnfinish(ip)
  	struct ite_softc *ip;
  {
  	static int done;
*** old-NetBSD/src/sys/arch/amiga/dev/itevar.h
--- NetBSD/src/sys/arch/amiga/dev/itevar.h
***************
*** 193,199 ****
  void	itecninit __P((struct consdev *));
  int	itecngetc __P((dev_t));
  void	itecnputc __P((dev_t, int));
! void	ite_cnfinish __P((struct ite_softc *));
  
  /* standard ite device entry points. */
  void	iteinit __P((dev_t));
--- 193,200 ----
  void	itecninit __P((struct consdev *));
  int	itecngetc __P((dev_t));
  void	itecnputc __P((dev_t, int));
! void	itecnfinish __P((struct ite_softc *));
! void	itecnpollc __P((dev_t dev,int on));
  
  /* standard ite device entry points. */
  void	iteinit __P((dev_t));
